# Modul: Editor fr Eigenschaften einer Bedingung bei Schleifen und IF-THENs
# 02.03.2002, 10.10.02
# i.linkweiler@gmx.de

from qt import *
from Statements import *

class LoopeditWidget(QWidget):
  "Editor fr Eigenschaften einer Bedingung bei Schleifen und IF-THENs"
  def __init__(self,*args):
    "Erzeugt ein QT-Widget"
    apply(QWidget.__init__,(self,) + args)
    self.setMinimumSize(320,120)
    self.resize(320,120)
    
    self.setCaption(_('Bedingungs-Editor'))
    self.icon=QPixmap("./icons/find.xpm")
    self.setIcon(self.icon)

    self.ok = QPushButton(_("&OK"),self,"ok")
    self.ok.setGeometry(40,95,75,24)
    self.connect(self.ok,SIGNAL("clicked()"),self.slotOk)

    self.abbruch = QPushButton(_("&Abbruch"),self,"abbruch")
    self.abbruch.setGeometry(120,95,75,24)
    self.connect(self.abbruch,SIGNAL("clicked()"),self.close)

    self.hilfe = QPushButton(_("&Hilfe"),self,"hilfe")
    self.hilfe.setGeometry(200,95,75,24)
    self.connect(self.hilfe,SIGNAL("clicked()"),self.slotHilfe)

    self.edit = QMultiLineEdit(self)
    self.edit.setGeometry(4,10,310,80)

    self.exitcmd=None

  def slotHilfe(self):
    import hilfe
    hilfe.zeigen("./readme/bedingung.html")

  def setexitcmd(self,cmd):
    " <cmd> kann aufgerufen werden, wenn Dialog mit OK beendet wurde."
    self.exitcmd=cmd

  def setitem(self,item):
    " Setze das zu bearbeitende Objekt."
    self.item=item
    self.edit.insertLine(item.condition)

  def slotOk(self):
    " Da hat wohl jemand OK geklickt."
    s=self.edit.text()
    t=unicode(s)
    self.item.setCond(t)

    if self.exitcmd!=None: 
      self.exitcmd()
    self.close(1)

def main():
    " Zum Test"
    STYLE="Qt"
    item=Loop(STYLE)

    a = QApplication(sys.argv)
    QObject.connect(a,SIGNAL('lastWindowClosed()'),a,SLOT('quit()'))
    w = LoopeditWidget()
    a.setMainWidget(w)
    
    w.setitem(item)
    w.show()
    a.exec_loop()

if __name__=="__main__":
  main()

